
//**************************************************************************
//**
//** I_SOUND.C
//**
//** Version:		1.0
//** Last Build:	-?-
//** Author:		jk
//**
//**************************************************************************

// HEADER FILES ------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include "h2def.h"
#include "r_local.h"
#include "p_local.h"    // for P_AproxDistance
#include "sounds.h"

// MACROS ------------------------------------------------------------------

//#define PRINT_DEBUG_INFO

#define DEFAULT_ARCHIVEPATH     "o:\\sound\\archive\\"
#define PRIORITY_MAX_ADJUST 10
#define DIST_ADJUST (MAX_SND_DIST/PRIORITY_MAX_ADJUST)

// TYPES -------------------------------------------------------------------

// EXTERNAL FUNCTION PROTOTYPES --------------------------------------------

//void MUS_SongPlayer();

// PUBLIC FUNCTION PROTOTYPES ----------------------------------------------

boolean S_StopSoundID(int sound_id, int priority);
//void I_UpdateCDMusic(void);

//int I_CDMusPlay(int track, int loop);

// PRIVATE FUNCTION PROTOTYPES ---------------------------------------------

// EXTERNAL DATA DECLARATIONS ----------------------------------------------

//extern void **lumpcache;
//extern HWND hWndMain;

// PUBLIC DATA DEFINITIONS -------------------------------------------------

//boolean i_CDMusic = false;
#define i_CDMusic		( gi.GetInteger(DD_MUSIC_DEVICE)==2 )
int s_CDTrack = 0;

boolean MusicPaused;

//int snd_Channels=8;
int snd_3D = 1;

/*int	snd_MusicDevice=1,    // current music card # (index to dmxCodes)
	snd_SfxDevice=0;      // current sfx card # (index to dmxCodes)*/

// These should be cvars.
/*int snd_MaxVolume,      // maximum volume for sound
	snd_MusicVolume;    // maximum volume for music*/

// PRIVATE DATA DEFINITIONS ------------------------------------------------

//static int musID;	// ID of the music timer.

// CODE --------------------------------------------------------------------


/*
===============================================================================

		MUSIC & SFX API

===============================================================================
*/

extern	sfxinfo_t	S_sfx[];
extern	musicinfo_t	S_music[];

/*#ifndef USEA3D
static	channel_t	Channel[MAX_CHANNELS];
#else*/
static	channel_t	*Channel = 0;
static	int			numChannels = 0;
//#endif

int					RegisteredSong = 0; //the current registered song.
static	int			NextCleanup;
//static	boolean		MusicPaused;
int					Mus_Song = -1;
static	int			Mus_LumpNum;
static	void		*Mus_SndPtr;
static	byte		*SoundCurve;

static	boolean		UseSndScript;
static	char		ArchivePath[128];

extern	int			startepisode;
extern	int			startmap;

// int AmbChan;

int S_GetSfxLumpNum(sfxinfo_t *sound)
{
	return gi.W_GetNumForName(sound->lumpname);	
}

//==========================================================================
//
// S_Start
//
//==========================================================================

void S_Start(void)
{
	S_StopAllSound();
	S_StartSong(gamemap, true);
}

//==========================================================================
//
// S_StartSong
//
//==========================================================================

void S_StartSong(int song, boolean loop)
{
	char *songLump;
	int track;

	if(i_CDMusic)
	{ // Play a CD track, instead
		if(s_CDTrack)
		{ // Default to the player-chosen track
			track = s_CDTrack;
		}
		else
		{
			track = P_GetMapCDTrack(gamemap);
		}
		if(track == gi.CD(DD_GET_CURRENT_TRACK,0) && gi.CD(DD_GET_TIME_LEFT,0) > 0
			&& gi.CD(DD_STATUS,0) == DD_PLAYING)
		{
			// The chosen track is already playing.
			return;
		}
		
		/*if(!gi.CD(DD_PLAY_LOOP, track))
		{
			if(loop)
			{
				i_CDMusicLength = 35*I_CDMusTrackLength(track);
				oldTic = gametic;
			}
			else
			{
				i_CDMusicLength = -1;
			}
			i_CDCurrentTrack = track;
		}*/
		if(gi.CD(loop? DD_PLAY_LOOP : DD_PLAY, track))
			gi.conprintf( "Error starting CD play (track %d).\n", track);
	}
	else
	{
		if(song == Mus_Song)
		{ // don't replay an old song
			return;
		}
		if(RegisteredSong)
		{
			//I_StopSong();
			//I_UnRegisterSong();
			gi.StopSong();
			if(UseSndScript)
			{
				gi.Z_Free(Mus_SndPtr);
			}
			else
			{
				//gi.Z_ChangeTag(lumpcache[Mus_LumpNum], PU_CACHE);
				gi.W_ChangeCacheTag(Mus_LumpNum, PU_CACHE);
			}
			RegisteredSong = 0;
		}
		songLump = P_GetMapSongLump(song);
		if(!songLump)
		{
			return;
		}
		if(UseSndScript)
		{
			char name[128];
			sprintf(name, "%s%s.lmp", ArchivePath, songLump);
			gi.ReadFile(name, (byte **)&Mus_SndPtr);
		}
		else
		{
			Mus_LumpNum = gi.W_GetNumForName(songLump);
			Mus_SndPtr = gi.W_CacheLumpNum(Mus_LumpNum, PU_MUSIC);
		}
		/*RegisteredSong = I_RegisterSong(Mus_SndPtr);
		I_PlaySong(loop); // 'true' denotes endless looping.*/

		RegisteredSong = gi.PlaySong(Mus_SndPtr, gi.W_LumpLength(Mus_LumpNum), loop);
		Mus_Song = song;
	}
}

//==========================================================================
//
// S_StartSongName
//
//==========================================================================

void S_StartSongName(char *songLump, boolean loop)
{
	int cdTrack;

	if(!songLump)
	{
		return;
	}
	if(i_CDMusic)
	{
		cdTrack = 0;

		if(!strcmp(songLump, "hexen"))
		{
			cdTrack = P_GetCDTitleTrack();
		}
		else if(!strcmp(songLump, "hub"))
		{
			cdTrack = P_GetCDIntermissionTrack();
		}
		else if(!strcmp(songLump, "hall"))
		{
			cdTrack = P_GetCDEnd1Track();
		}
		else if(!strcmp(songLump, "orb"))
		{
			cdTrack = P_GetCDEnd2Track();
		}
		else if(!strcmp(songLump, "chess") && !s_CDTrack)
		{
			cdTrack = P_GetCDEnd3Track();
		}
/*	Uncomment this, if Kevin writes a specific song for startup
		else if(!strcmp(songLump, "start"))
		{
			cdTrack = P_GetCDStartTrack();
		}
*/
		if(!cdTrack || (cdTrack == gi.CD(DD_GET_CURRENT_TRACK,0) && gi.CD(DD_GET_TIME_LEFT,0) > 0))
		{
			return;
		}
		if(!gi.CD(loop? DD_PLAY_LOOP : DD_PLAY, cdTrack))
		{
			/*if(loop)
			{
				i_CDMusicLength = 35*I_CDMusTrackLength(cdTrack);
				oldTic = gametic;
			}
			else
			{
				i_CDMusicLength = -1;
			}
			i_CDCurrentTrack = cdTrack;*/

			// Clear the user selection?
			s_CDTrack = false;
		}

	}
	else
	{
		if(RegisteredSong)
		{
			/*I_StopSong();
			I_UnRegisterSong();*/
			gi.StopSong();
			if(UseSndScript)
			{
				gi.Z_Free(Mus_SndPtr);
			}
			else
			{
				gi.W_ChangeCacheTag(Mus_LumpNum, PU_CACHE);
			}
			RegisteredSong = 0;
		}
		if(UseSndScript)
		{
			char name[128];
			sprintf(name, "%s%s.lmp", ArchivePath, songLump);
			gi.ReadFile(name, (byte **)&Mus_SndPtr);
		}
		else
		{
			Mus_LumpNum = gi.W_GetNumForName(songLump);
//			printf( " - songlump: %d\n", Mus_LumpNum);
			Mus_SndPtr = gi.W_CacheLumpNum(Mus_LumpNum, PU_MUSIC);
		}
//		RegisteredSong = I_RegisterSong(Mus_SndPtr);
		//I_PlaySong(/*RegisteredSong, */loop); // 'true' denotes endless looping.

		RegisteredSong = gi.PlaySong(Mus_SndPtr, gi.W_LumpLength(Mus_LumpNum), loop);
		Mus_Song = -1;
	}
}

//==========================================================================
//
// S_GetSoundID
//
//==========================================================================

int S_GetSoundID(char *name)
{
	int i;

	for(i = 0; i < NUMSFX; i++)
	{
		if(!strcmp(S_sfx[i].tagName, name))
		{
			return i;
		}
	}
	return 0;
}

//==========================================================================
//
// S_StartSound
//
//==========================================================================

void S_StartSound(mobj_t *origin, int sound_id)
{
	S_StartSoundAtVolume(origin, sound_id, 127);
}


#ifdef USEA3D
// Get a free channel, but also get rid of stopped channels.
channel_t *S_GetFreeChannel()
{
	int			i;
	channel_t	*chan;

	for(i=0; i<snd_Channels; i++)
	{
		if(!I_SoundIsPlaying(Channel[i].handle))
		{
			I_FreeHandle(Channel[i].handle);
			memset(Channel+i, 0, sizeof(channel_t));
			return Channel+i;
		}
	}
	// We need to allocate a new channel.
	Channel = realloc(Channel, sizeof(channel_t)*(++snd_Channels));
	chan = Channel + snd_Channels-1;
	memset(chan, 0, sizeof(channel_t));
	return chan;
}
#endif

//==========================================================================
//
// S_StartSoundAtVolume
//
//==========================================================================

void S_StartSoundAtVolume(mobj_t *origin, int sound_id, int volume)
{
	int dist;
	int absx;
	int absy;
#ifndef USEA3D
	int i, vol;
	int priority;
	int sep;
	int angle;
	int chan;

	static int sndcount = 0;
#endif

#ifdef USEA3D
	channel_t *channel;
#endif

	// We aren't playing any sounds now.
	//return;

	if(sound_id == 0 || gi.GetInteger(DD_SFX_VOLUME) == 0)
		return;
	if(origin == NULL)
	{
		origin = players[displayplayer].plr->mo;
	}
	if(volume == 0)
	{
		return;
	}

	// calculate the distance before other stuff so that we can throw out
	// sounds that are beyond the hearing range.
	if(players[displayplayer].plr->mo)
	{
		absx = abs(origin->x-players[displayplayer].plr->mo->x);
		absy = abs(origin->y-players[displayplayer].plr->mo->y);
		dist = absx+absy-(absx > absy ? absy>>1 : absx>>1);
		dist >>= FRACBITS;
		if(dist >= MAX_SND_DIST)
		{
		  return; // sound is beyond the hearing range...
		}
		if(dist < 0)
		{	
			dist = 0;
		}
	}
	else
	{
		// The player has no mo! Kind of strange...
		origin = NULL;	// Now one exists, I say.
		dist = 0;		// The sound is very close.
	}

#ifndef USEA3D
	priority = S_sfx[sound_id].priority;
	priority *= (PRIORITY_MAX_ADJUST-(dist/DIST_ADJUST));
	if(!S_StopSoundID(sound_id, priority))
	{
		return; // other sounds have greater priority
	}
	for(i=0; i<snd_Channels; i++)
	{
		if(origin)
		{
			if(origin->player)
			{
				i = snd_Channels;
				break; // let the player have more than one sound.
			}
		}
		else
		{
			// This sound is emitting from nowhere. Of course there 
			// can be lots of these!
			i = snd_Channels;
			break;
		}
		if(origin == Channel[i].mo)
		{ // only allow other mobjs one sound
			S_StopSound(Channel[i].mo);
			break;
		}
	}
	if(i >= snd_Channels)
	{
		for(i = 0; i < snd_Channels; i++)
		{
			if(Channel[i].mo == NULL)
			{
				break;
			}
		}
		if(i >= snd_Channels)
		{
			// look for a lower priority sound to replace.
			sndcount++;
			if(sndcount >= snd_Channels)
			{
				sndcount = 0;
			}
			for(chan = 0; chan < snd_Channels; chan++)
			{
				i = (sndcount+chan)%snd_Channels;
				if(priority >= Channel[i].priority)
				{
					chan = -1; //denote that sound should be replaced.
					break;
				}
			}
			if(chan != -1)
			{
				return; //no free channels.
			}
			else //replace the lower priority sound.
			{
				if(Channel[i].handle)
				{
					if(gi.SoundIsPlaying(Channel[i].handle))
					{
						gi.StopSound(Channel[i].handle);
					}
					if(S_sfx[Channel[i].sound_id].usefulness > 0)
					{
						S_sfx[Channel[i].sound_id].usefulness--;
					}
				}
			}
		}
	}
#endif

	if(S_sfx[sound_id].lumpnum == 0)
	{
		S_sfx[sound_id].lumpnum = S_GetSfxLumpNum(&S_sfx[sound_id]);
	}
	if(S_sfx[sound_id].snd_ptr == NULL)
	{
		if(UseSndScript)
		{
			char name[128];
			sprintf(name, "%s%s.lmp", ArchivePath, S_sfx[sound_id].lumpname);
			gi.ReadFile(name, (byte **)&S_sfx[sound_id].snd_ptr);
		}
		else
		{
			S_sfx[sound_id].snd_ptr = gi.W_CacheLumpNum(S_sfx[sound_id].lumpnum,PU_SOUND);
		}
	}

#ifndef USEA3D	
	// I had to move this here for the obvious reason that otherwise it's 
	// used before it's set. I don't really understand how this could have
	// worked before... Now it's just smashing. -jk
	Channel[i].mo = origin;

	vol = (SoundCurve[dist]*(15*8)*volume)>>14;

	// Thanks to DirectSound we'll bypass the SoundCurve. -jk
	//vol = ((256-dist*256/MAX_SND_DIST)*(snd_MaxVolume*8)*volume)>>14;

	if(origin == players[displayplayer].plr->mo)
	{
		sep = 128;
//		vol = (volume*(snd_MaxVolume+1)*8)>>7;
	}
	else
	{
		angle = R_PointToAngle2(players[displayplayer].plr->mo->x,
			players[displayplayer].plr->mo->y, Channel[i].mo->x, Channel[i].mo->y);
		angle = (angle-gi.GetInteger(DD_VIEWANGLE))>>24;
		sep = angle;
//		vol = SoundCurve[dist];
	}
	
	if(S_sfx[sound_id].changePitch)
	{
		Channel[i].pitch = (byte)(127+(M_Random()&7)-(M_Random()&7));
	}
	else
	{
		Channel[i].pitch = 127;
	}
	Channel[i].handle = gi.PlaySound(S_sfx[sound_id].snd_ptr, (vol*1000)/127,
		(sep*500)/128, (Channel[i].pitch*1000)/128);
//	Channel[i].mo = origin;
	Channel[i].sound_id = sound_id;
	Channel[i].priority = priority;
	Channel[i].volume = volume;
	if(S_sfx[sound_id].usefulness < 0)
	{
		S_sfx[sound_id].usefulness = 1;
	}
	else
	{
		S_sfx[sound_id].usefulness++;
	}

#else // USEA3D

	// We're relying on A3D to do most of the sound management. We'll just
	// find an empty channel and start a sound on it. Notice that channels
	// are dynamically allocated.

	channel = S_GetFreeChannel();	
	// Fill in all the data we can.
	channel->mo = origin;
	channel->priority = S_sfx[sound_id].priority;
	channel->sound_id = sound_id;
	channel->volume = volume;
	// Also the pitch.
	if(S_sfx[sound_id].changePitch)
		channel->pitch = (byte)(127+(M_Random()&7)-(M_Random()&7));
	else
		channel->pitch = 127;

	// Start playing the channel.
	I_StartSound(channel);

#endif // USEA3D

#ifdef PRINT_DEBUG_INFO
	printf( "PLAY:   i:%d handle:%d volume:%3d vol:%3d lump:%8s mo:%p\n", i, Channel[i].handle, 
		Channel[i].volume, vol, S_sfx[Channel[i].sound_id].lumpname, Channel[i].mo);
#endif
}

//==========================================================================
//
// S_StopSoundID
//
//==========================================================================

#ifndef USEA3D
boolean S_StopSoundID(int sound_id, int priority)
{
	int i;
	int lp; //least priority
	int found;

	if(S_sfx[sound_id].numchannels == -1)
	{
		return(true);
	}
	lp = -1; //denote the argument sound_id
	found = 0;
	for(i=0; i<snd_Channels; i++)
	{
		if(Channel[i].sound_id == sound_id && Channel[i].mo)
		{
			found++; //found one.  Now, should we replace it??
			if(priority >= Channel[i].priority)
			{ // if we're gonna kill one, then this'll be it
				lp = i;
				priority = Channel[i].priority;
			}
		}
	}
	if(found < S_sfx[sound_id].numchannels)
	{
		return(true);
	}
	else if(lp == -1)
	{
		return(false); // don't replace any sounds
	}
	if(Channel[lp].handle)
	{
		if(gi.SoundIsPlaying(Channel[lp].handle))
		{
			gi.StopSound(Channel[lp].handle);
		}
		if(S_sfx[Channel[lp].sound_id].usefulness > 0)
		{
			S_sfx[Channel[lp].sound_id].usefulness--;
		}
		Channel[lp].mo = NULL;
	}
	return(true);
}
#endif

//==========================================================================
//
// S_StopSound
//
//==========================================================================

void S_StopSound(mobj_t *origin)
{
	int i;

	for(i=0;i<snd_Channels;i++)
	{
		if(Channel[i].mo == origin)
		{
			gi.StopSound(Channel[i].handle);
			if(S_sfx[Channel[i].sound_id].usefulness > 0)
			{
				S_sfx[Channel[i].sound_id].usefulness--;
			}
			Channel[i].handle = 0;
			Channel[i].mo = NULL;
		}
	}
}

//==========================================================================
//
// S_StopAllSound
//
//==========================================================================

void S_StopAllSound(void)
{
	int i;

	//stop all sounds
	for(i=0; i < snd_Channels; i++)
	{
		if(Channel[i].handle)
		{
			S_StopSound(Channel[i].mo);
		}
	}
	memset(Channel, 0, snd_Channels*sizeof(channel_t));
}

//==========================================================================
//
// S_SoundLink
//
//==========================================================================

void S_SoundLink(mobj_t *oldactor, mobj_t *newactor)
{
	int i;

	for(i=0;i<snd_Channels;i++)
	{
		if(Channel[i].mo == oldactor)
			Channel[i].mo = newactor;
	}
}

//==========================================================================
//
// S_PauseSound
//
//==========================================================================

void S_PauseSound(void)
{
	if(i_CDMusic)
	{
		//I_CDMusStop();
		gi.CD(DD_STOP,0);
	}
	else
	{
		//I_PauseSong();
		gi.PauseSong();
	}
}

//==========================================================================
//
// S_ResumeSound
//
//==========================================================================

void S_ResumeSound(void)
{
	if(i_CDMusic)
	{
		//I_CDMusResume();
		gi.CD(DD_RESUME,0);
	}
	else
	{
		//I_ResumeSong();
		gi.ResumeSong();
	}
}

//==========================================================================
//
// S_UpdateSounds
//
//==========================================================================

//#define NO_SOUND_UPDATE	// Somehow it helps not to update the sounds.

void S_UpdateSounds(mobj_t *listener)
{
	int i;
#ifndef USEA3D
	int dist, vol;
	int angle;
	int sep;
	int absx;
	int absy;
	int priority;
#endif

	/*if(i_CDMusic)
	{
		I_UpdateCDMusic();

	}*/
	if(gi.GetInteger(DD_SFX_VOLUME) == 0)
	{
		return;
	}

	// Update any Sequences
	SN_UpdateActiveSequences();

	if(NextCleanup < gametic)
	{
		if(UseSndScript)
		{
			for(i = 0; i < NUMSFX; i++)
			{
				if(S_sfx[i].usefulness == 0 && S_sfx[i].snd_ptr)
				{
					S_sfx[i].usefulness = -1;
				}
			}
		}
		else
		{
			for(i = 0; i < NUMSFX; i++)
			{
				if(S_sfx[i].usefulness == 0 && S_sfx[i].snd_ptr)
				{
					/*if(lumpcache[S_sfx[i].lumpnum])
					{
						if(((memblock_t *)((byte*)
							(lumpcache[S_sfx[i].lumpnum])-
							sizeof(memblock_t)))->id == 0x1d4a11)
						{ // taken directly from the gi.Z_ChangeTag macro
							Z_ChangeTag2(lumpcache[S_sfx[i].lumpnum],
								PU_CACHE);
						}
					}*/
					gi.W_ChangeCacheTag(S_sfx[i].lumpnum, PU_CACHE);
					S_sfx[i].usefulness = -1;
					S_sfx[i].snd_ptr = NULL;
				}
			}
		}
		NextCleanup = gametic+35*30; // every 30 seconds
	}
	for(i=0; i<snd_Channels; i++)
	{
		if(!Channel[i].handle || S_sfx[Channel[i].sound_id].usefulness == -1)
		{
			continue;
		}

		// Take care of stopped sounds.
		if(!gi.SoundIsPlaying(Channel[i].handle))
		{
			if(S_sfx[Channel[i].sound_id].usefulness > 0)
			{
				S_sfx[Channel[i].sound_id].usefulness--;
			}
#ifdef USEA3D
			I_FreeHandle(Channel[i].handle);
#endif
			Channel[i].handle = 0;
			Channel[i].mo = NULL;
			Channel[i].sound_id = 0;
		}

		// Does this sound need updating?
		if(Channel[i].mo == NULL || Channel[i].sound_id == 0 || !listener)
			//|| Channel[i].mo == listener) 
		{
#ifdef PRINT_DEBUG_INFO
			printf( "UPD/CN: i:%d handle:%d volume:%3d vol:--- lump:%8s mo:%p\n", i, Channel[i].handle, 
				Channel[i].volume, S_sfx[Channel[i].sound_id].lumpname, Channel[i].mo);
#endif
			// No, apparently not.
			continue;
		}
		else
		{
#ifndef USEA3D
			absx = abs(Channel[i].mo->x - listener->x);
			absy = abs(Channel[i].mo->y - listener->y);
			dist = absx+absy-(absx > absy ? absy>>1 : absx>>1);
			dist >>= FRACBITS;

			if(dist >= MAX_SND_DIST)
			{
				S_StopSound(Channel[i].mo);
				continue;
			}
			if(dist < 0)
			{
				dist = 0;
			}
			vol = (SoundCurve[dist]*(15*8)*Channel[i].volume)>>14;
			
			// Thanks to DirectSound we'll bypass the SoundCurve. -jk
			//vol = ((256-dist*256/MAX_SND_DIST)*(snd_MaxVolume*8)*Channel[i].volume)>>14;

			if(Channel[i].mo == listener)
			{
				sep = 128;
			}
			else
			{
				angle = R_PointToAngle2(listener->x, listener->y,
								Channel[i].mo->x, Channel[i].mo->y);
				angle = (angle-gi.GetInteger(DD_VIEWANGLE))>>24;
				sep = angle*2-128;
				if(sep < 64)
					sep = -sep;
				if(sep > 192)
					sep = 512-sep;
			}
			gi.UpdateSound(Channel[i].handle, (vol*1000)/127, (500*sep)/128, (1000*Channel[i].pitch)/128);
			priority = S_sfx[Channel[i].sound_id].priority;
			priority *= PRIORITY_MAX_ADJUST-(dist/DIST_ADJUST);
			Channel[i].priority = priority;

#else // USEA3D
			
			I_UpdateSoundParams(Channel+i);

#endif

#ifdef PRINT_DEBUG_INFO
			printf( "UPDATE: i:%d handle:%d volume:%3d vol:%3d lump:%8s mo:%p\n", i, Channel[i].handle, 
				Channel[i].volume, vol, S_sfx[Channel[i].sound_id].lumpname, Channel[i].mo);
#endif
		}
		


	}
}

//==========================================================================
//
// S_Init
//
//==========================================================================

void S_Init(void)
{
	SoundCurve = gi.W_CacheLumpName("SNDCURVE", PU_STATIC);
//      SoundCurve = Z_Malloc(MAX_SND_DIST, PU_STATIC, NULL);

#ifndef USEA3D
	if(snd_Channels > 16)
	{
		snd_Channels = 16;
	}
	//I_SetChannels(snd_Channels);
#else
	snd_Channels = 0;
	Channel = NULL;
#endif

	//gi.SetMIDIVolume(snd_MusicVolume*16);
}

//==========================================================================
//
// S_GetChannelInfo
//
//==========================================================================

void S_GetChannelInfo(SoundInfo_t *s)
{
	int i;
	ChanInfo_t *c;

	s->channelCount = snd_Channels<16? snd_Channels : 16;
	s->musicVolume = 0;//snd_MusicVolume;
	s->soundVolume = 0;//snd_MaxVolume;
#ifdef USEA3D
	for(i = 0; i < s->channelCount; i++)
#else
	for(i = 0; i < snd_Channels; i++)
#endif
	{
		c = &s->chan[i];
		c->id = Channel[i].sound_id;
		c->priority = Channel[i].priority;
		c->name = S_sfx[c->id].lumpname;
		c->mo = Channel[i].mo;
		if(c->mo)
			c->distance = P_AproxDistance(c->mo->x-gi.GetInteger(DD_VIEWX), 
			c->mo->y-gi.GetInteger(DD_VIEWY))
				>>FRACBITS;
		else
			c->distance = -1;
	}
}

//==========================================================================
//
// S_GetSoundPlayingInfo
//
//==========================================================================

boolean S_GetSoundPlayingInfo(mobj_t *mobj, int sound_id)
{
	int i;

	for(i = 0; i < snd_Channels; i++)
	{
		if(Channel[i].sound_id == sound_id && Channel[i].mo == mobj)
		{
			if(gi.SoundIsPlaying(Channel[i].handle))
			{
				return true;
			}
		}
	}
	return false;
}

//==========================================================================
//
// S_SetMusicVolume
//
//==========================================================================

/*void S_SetMusicVolume(int vol)
{
	if(i_CDMusic)
	{
		//I_CDMusSetVolume(snd_MusicVolume*16); // 0-255
		gi.CD(DD_SET_VOLUME, vol);//snd_MusicVolume*16);
	}
	else
	{
		//I_SetMusicVolume(snd_MusicVolume);
		gi.SetMIDIVolume(vol);//snd_MusicVolume);
	}
	if(vol == 0)
	{
		if(!i_CDMusic)
		{
			//I_PauseSong();
			gi.PauseSong();
		}
		MusicPaused = true;
	}
	else if(MusicPaused)
	{
		if(!i_CDMusic)
		{
			//I_ResumeSong();
			gi.ResumeSong();
		}
		MusicPaused = false;
	}
}*/

//==========================================================================
//
// S_ShutDown
//
//==========================================================================

void S_ShutDown(void)
{
/*	extern boolean timerInstalled;
	if(timerInstalled)
	{
		I_StopSong();
		I_UnRegisterSong();
		I_ShutdownSound();
	}
	if(i_CDMusic)
	{
		I_CDMusStop();
	}*/
#ifdef USEA3D
	free(Channel);
	Channel = 0;
	snd_Channels = 0;
#endif
}

void S_Reset(void)
{
	int		i;

	gi.Z_FreeTags(PU_SOUND, PU_SOUND);
	for(i=0; i<NUMSFX; i++)
	{
		S_sfx[i].lumpnum = 0;
		S_sfx[i].snd_ptr = NULL;				
	}
	// Music, too.
	if(RegisteredSong)
	{
		/*I_StopSong();
		I_UnRegisterSong();*/
		gi.StopSong();
		if(UseSndScript)
			gi.Z_Free(Mus_SndPtr);
		else
			//gi.Z_ChangeTag(lumpcache[Mus_LumpNum], PU_CACHE);
			gi.W_ChangeCacheTag(Mus_LumpNum, PU_CACHE);
		RegisteredSong = 0;
	}
	Mus_Song = -1;
}

//==========================================================================
//
// S_InitScript
//
//==========================================================================

void S_InitScript(void)
{
	int p;
	int i;

	strcpy(ArchivePath, DEFAULT_ARCHIVEPATH);
	if(!(p = gi.CheckParm("-devsnd")))
	{
		UseSndScript = false;
		SC_OpenLump("sndinfo");
	}
	else
	{
		UseSndScript = true;
		SC_OpenFile(gi.Argv(p+1));
	}
	while(SC_GetString())
	{
		if(*sc_String == '$')
		{
			if(!stricmp(sc_String, "$ARCHIVEPATH"))
			{
				SC_MustGetString();
				strcpy(ArchivePath, sc_String);
			}
			else if(!stricmp(sc_String, "$MAP"))
			{
				SC_MustGetNumber();
				SC_MustGetString();
				if(sc_Number)
				{
					P_PutMapSongLump(sc_Number, sc_String);
				}
			}
			continue;
		}
		else
		{
			for(i = 0; i < NUMSFX; i++)
			{
				if(!strcmp(S_sfx[i].tagName, sc_String))
				{
					SC_MustGetString();
					if(*sc_String != '?')
					{
						strcpy(S_sfx[i].lumpname, sc_String);
					}
					else
					{
						strcpy(S_sfx[i].lumpname, "default");
					}
					break;
				}
			}
			if(i == NUMSFX)
			{
				SC_MustGetString();
			}
		}
	}
	SC_Close();

	for(i = 0; i < NUMSFX; i++)
	{
		if(!strcmp(S_sfx[i].lumpname, ""))
		{
			strcpy(S_sfx[i].lumpname, "default");
		}
	}
}


//==========================================================================
//
// CONSOLE COMMANDS
//
//==========================================================================

int CCmdCD(int argc, char **argv)
{
	if(argc > 1)
	{
		if(!strcmpi(argv[1], "init"))
		{
			if(!gi.CD(DD_INIT,0))
				gi.conprintf( "CD init successful.\n");
			else
				gi.conprintf( "CD init failed.\n");
		}
		else if(!strcmpi(argv[1], "info") && argc == 2)
		{
			int secs = gi.CD(DD_GET_TIME_LEFT,0);//i_CDMusicLength/35;
			gi.conprintf( "CD available: %s\n", gi.CD(DD_AVAILABLE,0)? "yes" : "no");
			gi.conprintf( "First track: %d\n", gi.CD(DD_GET_FIRST_TRACK,0));
			gi.conprintf( "Last track: %d\n", gi.CD(DD_GET_LAST_TRACK,0));
			gi.conprintf( "Current track: %d\n", gi.CD(DD_GET_CURRENT_TRACK,0));
			gi.conprintf( "Time left: %d:%02d\n", secs/60, secs%60);
			gi.conprintf( "Play mode: ");
			if(MusicPaused)
				gi.conprintf( "paused\n");
			else if(s_CDTrack)
				gi.conprintf( "looping track %d\n", s_CDTrack);
			else
				gi.conprintf( "map track\n");
			return true;
		}
		else if(!strcmpi(argv[1], "play") && argc == 3)
		{
			s_CDTrack = atoi(argv[2]);
			if(!gi.CD(DD_PLAY_LOOP, s_CDTrack)) 
			{
				gi.conprintf( "Playing track %d.\n", s_CDTrack);
			}
			else
			{
				gi.conprintf( "Error playing track %d.\n", s_CDTrack);
				return false;
			}
		}
		else if(!strcmpi(argv[1], "map"))
		{
			int track;
			int mapnum = gamemap;
			if(argc == 3) mapnum = atoi(argv[2]);
			s_CDTrack = false;	// Clear the user selection.
			track = P_GetMapCDTrack(mapnum);			
			if(!gi.CD(DD_PLAY_LOOP, track)) // Uses s_CDTrack.
			{
				gi.conprintf( "Playing track %d.\n", track);
			}
			else
			{
				gi.conprintf( "Error playing track %d.\n", track);
				return false;
			}
		}
		else if(!strcmpi(argv[1], "stop") && argc == 2)
		{
			gi.CD(DD_STOP,0);
			gi.conprintf( "CD stopped.\n");
		}
		else if(!strcmpi(argv[1], "resume") && argc == 2)
		{
			gi.CD(DD_RESUME,0);//I_CDMusResume();
			gi.conprintf( "CD resumed.\n");
		}
		else
			gi.conprintf( "Bad command. Try 'cd'.\n");
	}
	else
	{
		gi.conprintf( "CD player control. Usage: CD (cmd)\n");
		gi.conprintf( "Commands are: init, info, play (track#), map, map (#), stop, resume.\n");
	}
	return true;
}

int CCmdMidi(int argc, char **argv)
{
	if(argc == 1)
	{
		gi.conprintf( "Usage: midi (cmd)\n");
		gi.conprintf( "Commands are: reset, play (name), map, map (num).\n");
		return true;
	}
	if(argc == 2)
	{
		if(!strcmpi(argv[1], "reset"))
		{
			if(RegisteredSong)
			{
				/*I_StopSong();
				I_UnRegisterSong();*/
				gi.StopSong();
				if(UseSndScript)
					gi.Z_Free(Mus_SndPtr);
				else
					//gi.Z_ChangeTag(lumpcache[Mus_LumpNum], PU_CACHE);
					gi.W_ChangeCacheTag(Mus_LumpNum, PU_CACHE);
				RegisteredSong = 0;
			}
			Mus_Song = -1;
			gi.conprintf( "MIDI has been reset.\n");
		}
		else if(!strcmpi(argv[1], "map")) 
		{
			gi.conprintf( "Playing the song of the current map (%d).\n", gamemap);
			S_StartSong(gamemap, true);
		}
		else
			return false;
	}
	else if(argc == 3)
	{
		if(i_CDMusic)
		{	
			gi.conprintf( "MIDI is not the current music device.\n");
			return true;
		}
		if(!strcmpi(argv[1], "play"))
		{
			gi.conprintf( "Playing song '%s'.\n", argv[2]);
			S_StartSongName(argv[2], true);
		}
		else if(!strcmpi(argv[1], "map"))
		{
			gi.conprintf( "Playing song for map %d.\n", atoi(argv[2]));
			S_StartSong(atoi(argv[2]), true);
		}
		else
			return false;
	}
	else 
		return false;
	// Oh, we're done.
	return true;
}

int CCmdSndChannels(int argc, char **argv)
{
	if(argc == 1)	// No arguments?
	{
		gi.conprintf("Sound channels: %d.\n", snd_Channels);
	}
	else if(argc == 2) // Set the number of channels?
	{
		int num = atoi(argv[1]);
		if(num > 0 && num <= 16) 
		{
			//I_SetChannels(num);
			snd_Channels = num;
			gi.conprintf( "Using %d sound channels.\n", snd_Channels);
		}
		else
		{
			gi.conprintf( "%d is not a valid number of channels.\n", num);
			return false;
		}
	}
	else
		gi.conprintf( "Usage: sndchannels (num)\n");
	return true;
}
