// SessionDlg.cpp : implementation file
//

#include "stdafx.h"
#include "jtNet.h"
#include "SessionDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSessionDlg dialog


CSessionDlg::CSessionDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSessionDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSessionDlg)
	m_listSel = -1;
	//}}AFX_DATA_INIT
}


void CSessionDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSessionDlg)
	DDX_Control(pDX, IDC_SESSION_LIST, m_list);
	DDX_LBIndex(pDX, IDC_SESSION_LIST, m_listSel);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSessionDlg, CDialog)
	//{{AFX_MSG_MAP(CSessionDlg)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSessionDlg message handlers

BOOL CSessionDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	DPCAPS caps;
	memset(&caps, 0, sizeof(caps));
	caps.dwSize = sizeof(caps);
	dPlay->GetCaps(&caps, 0);
	timerId = SetTimer(1, caps.dwTimeout, NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CSessionDlg::OnClose() 
{
	KillTimer(timerId);
	
	CDialog::OnClose();
}

void CSessionDlg::OnTimer(UINT nIDEvent) 
{
	if(nIDEvent == 1)
	{
		bool restoreSel = false;
		GUID oldGuid;
		// Remember the current selection by looking at the game GUID.
		if(m_list.GetCurSel() != -1)
		{
			restoreSel = true;
			memcpy(&oldGuid, &sessions[m_list.GetCurSel()].desc.guidInstance, sizeof(GUID));
		}
		// We need to update the list of sessions.
		jtEnumerateSessions();
	
		m_list.ResetContent();
	
		// Add the sessions to the list.
		for(int i=0; i<numSessions; i++)
		{
			CString str;
			str.Format("%s (%d/%d)", sessions[i].name, sessions[i].desc.dwCurrentPlayers, 
				sessions[i].desc.dwMaxPlayers);
			m_list.AddString(str);
		}

		// Look up the old selection.
		if(restoreSel)
		{
			for(i=0; i<numSessions; i++)
				if(!memcmp(&oldGuid, &sessions[i].desc.guidInstance, sizeof(GUID)))
				{
					m_list.SetCurSel(i);
					break;
				}
		}
	}

	CDialog::OnTimer(nIDEvent);
}

