// jtNet.h : main header file for the JTNET DLL
//

#if !defined(AFX_JTNET_H__041C07A7_84B1_11D3_B689_E29406BD95EC__INCLUDED_)
#define AFX_JTNET_H__041C07A7_84B1_11D3_B689_E29406BD95EC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols
#include "jtNetEx.h"

/////////////////////////////////////////////////////////////////////////////
// CJtNetApp
// See jtNet.cpp for the implementation of this class
//

class CJtNetApp : public CWinApp
{
public:
	CJtNetApp();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CJtNetApp)
	//}}AFX_VIRTUAL

	//{{AFX_MSG(CJtNetApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

struct jtnetcon_t
{
	GUID	guid;
	int		type;			// JTNET_SERVICE_*
	void	*connection;	// The connection data.
	int		size;			// Size of the connection data.
	char	name[100];		
};

struct jtnetsession_t
{
	DPSESSIONDESC2		desc;
	char				name[64];
	char				info[128];
};

#ifndef JTNET_DX3
extern LPDIRECTPLAY4A	dPlay;
#else
extern LPDIRECTPLAY2A	dPlay;
#endif

extern jtnetcon_t		*connections;
extern int				numConnections;
extern jtnetsession_t	*sessions;
extern int				numSessions;
extern jtnetplayer_t	*players;
extern int				numPlayers;

int jtEnumerateSessions();
int jtEnumeratePlayers();

// Version information.
#define JTNET_VERSION_NUM			200
#define JTNET_VERSION_STR			"2.0"

#ifndef JTNET_DX3
#define JTNET_VER_ID				"DX6 BETA"
#else
#define JTNET_VER_ID				"DX3 BETA"
#endif

#define JTNET_VERSION_FULL			"jtNet Version 2.0 "__DATE__" ("JTNET_VER_ID")"

// jtNet messages.
#define JTNET_MSG_BEGIN_SESSION		0xffff0000
#define JTNET_MSG_OK				0xffff1234
#define JTNET_MSG_CANCEL			0xffff4321

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_JTNET_H__041C07A7_84B1_11D3_B689_E29406BD95EC__INCLUDED_)
